/* WIDGET-SPECIFIC FUNCTIONS */
var urlArray = [
  'http://www.linkedin.com/search?search=&keywords=',
  'http://www.linkedin.com/jobs?runSearch=&keywords=',
  'http://www.linkedin.com/searchAnswers?runSearch=&keywords=',
  'http://www.linkedin.com/groupsDirectory?search=&keywords=',
  'http://www.linkedin.com/mbox?search=&keywords='
];

function setup() {
  if (window.widget) {
    if (widget.preferenceForKey('searchType')) {
      var pref = widget.preferenceForKey('searchType');
      document.getElementById('popmenu').options[pref].selected = true;
      document.getElementById('popmenutext').innerText = document.getElementById('popmenu').options[pref].value;
    }
  }  
}

function submit(str) {
  var baseURL = urlArray[document.getElementById('popmenu').selectedIndex];
  var searchStr = str.value;
  if (searchStr.length > 0) {
    var searchURL = baseURL + searchStr;
    if (window.widget) widget.openURL(searchURL);
  }
}

function popupChanged(elem) {
  var chosenOption = elem.options[elem.selectedIndex].value;
  document.getElementById('popmenutext').innerText = chosenOption;
  
  if (window.widget) widget.setPreferenceForKey(elem.selectedIndex,'searchType');
}

function goHome() {
  if (window.widget) widget.openURL('http://www.linkedin.com/');
}


/* GENERIC ANIMATION FUNCTIONS */
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function showBack() {
  var front = document.getElementById('front');
  var back = document.getElementById('back');
  
  if (window.widget) widget.prepareForTransition('ToBack');
  
  front.style.display = 'none';
  back.style.display = 'block';
  
  if (window.widget) setTimeout('widget.performTransition();',0);
  
  document.getElementById('fliproll').style.display = 'none';
}

function showFront() {
  var front = document.getElementById('front');
  var back = document.getElementById('back');
  
  if (window.widget) widget.prepareForTransition('ToFront');
  
  back.style.display = 'none';
  front.style.display = 'block';
  
  if (window.widget) setTimeout('widget.performTransition();',0);
}

function mouseMove(event)
{
  if (!flipShown) {
    if (animation.timer != null) {
      clearInterval(animation.timer);
      animation.timer  = null;
    }

    var starttime = (new Date).getTime() - 13;

    animation.duration = 500;
    animation.starttime = starttime;
    animation.firstElement = document.getElementById('flip');
    animation.timer = setInterval('animate();', 13);
    animation.from = animation.now;
    animation.to = 1.0;
    animate();
    flipShown = true;
  }
}

function mouseExit(event)
{
  if (flipShown) {
    if (animation.timer != null) {
      clearInterval(animation.timer);
      animation.timer  = null;
    }

    var starttime = (new Date).getTime() - 13;

    animation.duration = 500;
    animation.starttime = starttime;
    animation.firstElement = document.getElementById('flip');
    animation.timer = setInterval('animate();', 13);
    animation.from = animation.now;
    animation.to = 0.0;
    animate();
    flipShown = false;
  }
}

function animate()
{
  var T, ease;
  var time = (new Date).getTime();

  T = limit_3(time-animation.starttime, 0, animation.duration);

  if (T >= animation.duration) {
    clearInterval (animation.timer);
    animation.timer = null;
    animation.now = animation.to;
  } else {
    ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
    animation.now = computeNextFloat (animation.from, animation.to, ease);
  }

  animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
  return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
  return from + (to - from) * ease;
}

function enterFlip(event) {
  document.getElementById('fliproll').style.display = 'block';
}

function exitFlip(event) {
  document.getElementById('fliproll').style.display = 'none';
}